题解#3

感觉自己弱得没救了。。。求神犇解救T_T

1

2597: [Wc2007]剪刀石头布

补集转化之后就是费用流了。我比较逗方案WA了两发。

 1 int n,m,k,mincost,tot=1,cnt,s,t,win[maxn],a[maxn][maxn],b[maxn][maxn],head[maxm],d[maxm],from[2*maxm];
 2
 3 bool v[maxm];
 4
 5 queue<int>q;
 6
 7 struct edge{int from,go,next,v,c;}e[2*maxm];
 8
 9 void add(int x,int y,int v,int c)
10
11 {
12
13     e[++tot]=(edge){x,y,head[x],v,c};head[x]=tot;
14
15     e[++tot]=(edge){y,x,head[y],0,-c};head[y]=tot;
16
17 }
18
19 bool spfa()
20
21 {
22
23     for (int i=0;i<=cnt;i++){v[i]=0;d[i]=inf;}
24
25     q.push(s);d[s]=0;v[s]=1;
26
27     while(!q.empty())
28
29     {
30
31         int x=q.front();q.pop();v[x]=0;
32
33         for (int i=head[x],y;i;i=e[i].next)
34
35          if(e[i].v&&d[x]+e[i].c<d[y=e[i].go])
36
37          {
38
39             d[y]=d[x]+e[i].c;from[y]=i;
40
41             if(!v[y]){v[y]=1;q.push(y);}
42
43          }
44
45     }
46
47     return d[t]!=inf;
48
49 }
50
51 void mcf()
52
53 {
54
55     while(spfa())
56
57     {
58
59         int tmp=inf;
60
61         for(int i=from[t];i;i=from[e[i].from]) tmp=min(tmp,e[i].v);
62
63         mincost+=d[t]*tmp;
64
65         for(int i=from[t];i;i=from[e[i].from]){e[i].v-=tmp;e[i^1].v+=tmp;}
66
67     }
68
69 }
70
71 int main()
72
73 {
74     n=read();s=0;t=n+1;cnt=t;
75     for5(n,n)a[i][j]=read(),win[i]+=(a[i][j]==1);
76     for1(i,n)for1(j,i-1)if(a[i][j]==2)
77     {
78         add(s,++cnt,1,0);
79         b[i][j]=tot+1;
80         add(cnt,i,1,0);
81         add(cnt,j,1,0);
82     }
83     for1(i,n)
84     {
85         mincost+=win[i]*(win[i]-1)/2;
86         for2(j,win[i],n-2)add(i,t,1,j);
87     }
88     mcf();
89     cout<<(n*(n-1)*(n-2)/6-mincost)<<endl;
90     for1(i,n)for1(j,i-1)if(a[i][j]==2)a[i][j]=!e[b[i][j]].v,a[j][i]=!a[i][j];
91     for1(i,n)for1(j,n)printf("%d%c",a[i][j],j==n?‘\n‘:‘ ‘);
92
93     return 0;
94
95 }  

时间: 2024-10-11 12:43:21

题解#3的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H

POJ 2386 Lake Counting 搜索题解

简单的深度搜索就可以了,看见有人说什么使用并查集,那简直是大算法小用了. 因为可以深搜而不用回溯,故此效率就是O(N*M)了. 技巧就是增加一个标志P,每次搜索到池塘,即有W字母,那么就认为搜索到一个池塘了,P值为真. 搜索过的池塘不要重复搜索,故此,每次走过的池塘都改成其他字母,如'@',或者'#',随便一个都可以. 然后8个方向搜索. #include <stdio.h> #include <vector> #include <string.h> #include